/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GUI

#include "glgui_cursor.h"
#include "color.h"

namespace OrxGui
{

  /**
   * standard constructor
  */
  GLGuiCursor::GLGuiCursor ()
  {
    this->init();

    this->subscribeEvent(ES_MENU,  EV_MOUSE_MOTION);


  }


  /**
   * @brief standard deconstructor
   */
  GLGuiCursor::~GLGuiCursor()
  {}

  float GLGuiCursor::_mouseSensitivity = 1.0;


  /**
   * @brief initializes the GUI-element
   */
  void GLGuiCursor::init()
  {
    this->setClassID(CL_GLGUI_CURSOR, "GLGuiCursor");

    this->backMaterial().setDiffuse(1.0,0.0,0.0);
    this->backMaterial().setDiffuseMap("cursor.png");
    this->setSize2D(10, 20);
    this->setAbsCoor2D(100, 100);
    this->setLayer(E2D_LAYER_ABOVE_ALL);

  }

  void GLGuiCursor::tick(float dt)
  {
    Vector color;
    this->backMaterial().getDiffuseColor(color.x, color.y, color.z);
    color =  Color::HSVtoRGB(Color::RGBtoHSV(color)+Vector(80.0*dt,0.0,.0));
    this->backMaterial().setDiffuse(color.x, color.y, color.z);

    if (this->movement != Vector2D())
    {
/*      if (this->getAbsCoor2D().x < 0.0 )
        movement.x = -this->getAbsCoor2D().x;
      if (this->getAbsCoor2D().x > 200.0)
        movement.x = (200.0-this->getAbsCoor2D().x);
      if (this->getAbsCoor2D().y < 0.0 )
        movement.x = -this->getAbsCoor2D().y;
      if (this->getAbsCoor2D().y > 200.0)
        movement.x = (200.0-this->getAbsCoor2D().y);*/



      //this->shiftCoor2D(movement);
      this->setAbsCoor2D(newPos);
      movement = Vector2D();
    }
  }

  /**
   * @brief draws the GLGuiCursor
   */
  void GLGuiCursor::draw() const
  {
    this->startDraw();
    GLGuiWidget::draw();
    this->endDraw();
  }

  void GLGuiCursor::process(const Event& event)
  {
    switch (event.type)
    {
      case EV_MOUSE_MOTION:
        newPos = Vector2D(event.x, event.y);
        movement += Vector2D(event.xRel * _mouseSensitivity, event.yRel * _mouseSensitivity);
        break;

    }
  }
}
